/*Programa de compression y decompression de archivos
de extencion psp,iso con Java funcionando en windows y linux*/


   import java.io.*;
   import java.awt.*;
   import java.awt.event.*;
   import javax.swing.*;
   import javax.swing.SwingUtilities;
   import javax.swing.filechooser.*;
   import javax.swing.event.*;
   import java.lang.Runtime;
   import java.lang.Process;
   import java.io.IOException;
   import java.util.*;

/*Clase principale*/

    public class CondorISO extends JPanel implements ActionListener{
   
   			/*Declaracion de todas las variables, butones, paneles etc...*/		
   							  
      static private final String newline = "\n"; 
      JButton openButton,comprimirButton;
      JLabel entradalabel,salidalabel,accionlabel,opcionlabel,otropcion;
      JPanel panel1,panel2,panel3,panel4;
      JFileChooser fc;
      JTextField salida,opciones;
      JComboBox actlist,oplist;
      
   	/*Cada string sirve para la linea
   	de comando para ejecutar Cisoplus*/
   	
      String opcion,accion,filesalida,cmd,filentrada=null;
   	
      int A=1,error=1,success;
   
   /*Metodo constructor de la clase, inicialisa todo (variables, botones, listas, etiquetas, boxes)*/
   
       public CondorISO() { 
       
         /*Creacion de la grilla : comparte la ventana en 5 partes iguales*/ 
      	
         super(new GridLayout(5,1));
      
        /*String que encontramos en las cajas de listas*/
        
         String[] actstring = {"Decompress", "Compress","Estimate compression"};		
         String[] opstring = {"Compression level", "Optimized compression", "Thread compression","Estimation quality","Threashold specified","Video files(NC areas)","Audio files(NC areas)","Add files(NC areas)","Video files (lost areas)","Audio files(lost areas)","Add files (Lost areas)","Ninguna"};	
         	
       /*Para elijir el archivo de entrada*/
         fc = new JFileChooser();
      
      	  /*Etiquetas*/
         entradalabel = new JLabel ("Archivo de entrada");
         salidalabel = new JLabel ("Achivo de salida,presione enter para validar");
         accionlabel = new JLabel ("Elija la accion");
         opcionlabel = new JLabel ("Elija la opcion");
         otropcion = new JLabel();
        
        /*Ingresar al teclado*/
         salida = new JTextField(20);
         opciones = new JTextField(20);
      
       /*Opciones de trabajo*/
         oplist = new JComboBox (opstring);
         actlist = new JComboBox (actstring);
      	  
         openButton = new JButton("Archivo a operar");
         comprimirButton = new JButton ("Operar");
      
        /*panel : puede contenir varias objetos (JTextField + Label + button etc...)*/
         panel1 = new JPanel();
         panel2 = new JPanel();
         panel3 = new JPanel();
         panel4 = new JPanel();
      
      	  /*Asociamos listener a ciertos objetos*/
         actlist.setSelectedIndex(2);
         actlist.addActionListener(this);
       
         ocultarboxopcion();
        		  
         oplist.setSelectedIndex(11);
         oplist.addActionListener(this);
      
         openButton.addActionListener(this); 
         comprimirButton.setEnabled(false);
         comprimirButton .addActionListener(this);
      
         salida.addActionListener(this);    
         opciones.addActionListener(this);  
        
      /*Asociamos objetos a paneles*/
         panel1.add(openButton);panel1.add(entradalabel);
         panel2.add(salidalabel);panel2.add(salida);
         panel3.add(accionlabel);panel3.add(actlist);
         panel4.add(opcionlabel);panel4.add(oplist);panel4.add(otropcion);panel4.add(opciones);
         add(panel1);add(panel2);add(panel3);add(panel4);add(comprimirButton);
      
      }
   
   
       public void actionPerformed(ActionEvent e) {
      
        //Handle open button action.
         
         if (e.getSource() == openButton) {
         
         /*El algoritmo que viene es para verificar que el 
         archivo de entrada tiene una de las extenciones 
         exigidas en nuestra applicacion
         Si la extencion eligida conviene (.psp,.iso,.cso), entonces, 
         el user puede continuar*/
         
            StringTokenizer tmp;
            String extencion;
         
            for (;;){
            
               int returnVal = fc.showOpenDialog(CondorISO.this);
            
               if (returnVal == JFileChooser.APPROVE_OPTION) {
               
               	/*File retornado*/
                  File file = fc.getSelectedFile(); 
                  filentrada = file.getAbsolutePath();
               
                  tmp=new StringTokenizer(filentrada);
               
                  /*Tomamos la extencion*/
               	
                  extencion=tmp.nextToken(".");
                  extencion=tmp.nextToken();
                
                  if (extencion.compareTo("iso")==0||extencion.compareTo("psp")==0||extencion.compareTo("cso")==0){
                  
                  /*Esta bueno, entonces el user puede continuar y operar (error=0)*/
                  
                     System.out.println(filentrada);
                     entradalabel.setText("Fichero: " + file.getName() + ".");
                     break;
                  /*Entonces sale de la boucla*/
                  
                    
                  
                  } 
                  
                  else {
                     entradalabel.setText("Fichero no valido, elije un otro");
                     JOptionPane.showMessageDialog(null,"Fichero no valido, elije un otro");
                     error=1; //No podra operar
                     comprimirButton.setEnabled(false);
                  /*Queda en la boucla*/
                  }
               }	
               else 
                  break;
            
            }
         }
         
         /*Texto ingresado en salida + enter presionado*/
         
         else if  (e.getSource() == salida){
         
         /*Misma algoritmo : quere verificar la extencion del 
         archivo ingresado al teclado*/
         
            StringTokenizer tmp;
            String extencion;
         
            filesalida = salida.getText();
            tmp=new StringTokenizer(filesalida);
            extencion=tmp.nextToken(".");
            extencion=tmp.nextToken();
            System.out.println(filesalida);
         		
            if (extencion.compareTo("iso")==0||extencion.compareTo("psp")==0||extencion.compareTo("cso")==0){
            //Entonces podra operar
               salidalabel.setText("El archivo de salida :"+filesalida);
               error=0;
            }
            
            else {
               salidalabel.setText("Fichero no valido, escribe un otro");
               filesalida = null;
               salida.setText("");
               comprimirButton.setEnabled(false);//no podra operar
               error=1;
               JOptionPane.showMessageDialog(null,"Fichero no valido, elije un otro");
            }
         }
                  
         //Accion eligida
         
         else if  (e.getSource() == actlist){
         
            if (error==0)
            
            /*Podemos operar si les nombres de los archivos ingresados
            son buenos*/ 
            
               comprimirButton.setEnabled(true);
         	
         	/*Consideramos la fuente de la interrupcion 
         	en la caja de lista*/
         	
            JComboBox cb = (JComboBox)e.getSource();
         
            switch (cb.getSelectedIndex()){ 
            
               /*Llenamos la cadena representativa de la accion
            	eligida*/
               case 0 : accion = "-dec ";
                  break;
            
               case 1 : accion="-com ";
                  break;
            
               case 2 : accion="-est ";
                  break;
            }
         
            System.out.println(accion);
         }
         
          /*Opcion eligida
          Depende de la opcion eligida, tenemos que elegir otros
          parametros. Entonces, podemos ingresar este parametro
          en un otro JTextField opciones. Segun la opcion elegida, 
          este JTextField aparece o no*/
            
         else if  (e.getSource() == oplist){
         
            JComboBox cb = (JComboBox)e.getSource();
            
            switch (cb.getSelectedIndex()){
            /*Llenamos la cadena representativa del opcion 
            elegida*/
               case 0 : opcion="-l";
                  mostrarboxopcion(); //Otro JtextField aparece
                  otropcion.setText("Level compression(entre 1 y 9)");
                  break;
            
               case 1 : opcion="-opt ";ocultarboxopcion();//Otro JtextField desaparece
                  break;
            
               case 2 : opcion="-MT ";ocultarboxopcion();
                  break;
            
               case 3 : opcion="-q";
                  mostrarboxopcion();
                  otropcion.setText("Estimation quality (entre 1 y 9),presione enter para validar");
                  break;
            
               case 4 : opcion="-t";
                  mostrarboxopcion();
                  otropcion.setText("Threashold level (entre 0 y 99),presione enter para validar");
                  break;
               	
               case 5 : opcion="-vid ";ocultarboxopcion();
                  break;
            
               case 6 : opcion="-aud ";ocultarboxopcion();
                  break;
            
               case 7 : opcion="-ext";
                  mostrarboxopcion();
                  otropcion.setText("Extension a eliminar en la compression,presione enter para validar");
                  break;
            
               case 8 : opcion="-rm_aud ";ocultarboxopcion();
                  break;
            
               case 9 : opcion="-rm_ext ";ocultarboxopcion();
                  break;
            
               case 10 :opcion="-rm_update ";ocultarboxopcion();
                  break;
                  	
               case 11 :opcion=null;ocultarboxopcion();
                  break;
            }
            
         
            System.out.println(opcion);
         }
         
         else if  (e.getSource() == opciones){
         //segun parametro de opcion
            opcion=opcion.concat(opciones.getText()+ " ");
            System.out.println(opcion);
         }
         
         
         		/*Boton operar presionado*/			  
         else if  (e.getSource() == comprimirButton){
         
            int i;
            
         	/*tenemos a este momento todas la cadenas para ejecutar cisoplus*/
         	
            String tmp;		  
            Runtime runTime = Runtime.getRuntime();
            Process child = null; //creacion del proceso
            
            cmd = "CisoPlus.exe ";
            cmd=cmd.concat(accion);
         		  
            if (opcion!=null)
               cmd=cmd.concat(opcion);
         				 
            cmd=cmd.concat(filentrada);
            cmd=cmd.concat(" ");
            cmd=cmd.concat(filesalida);
            /*Concatenas todas las cadenas
         	en cmd (comando)*/
            System.out.println(cmd);
         
            try{   
            
               /*Ejecucion de cmd : nuevo proceso demarra*/
               child = runTime.exec(cmd); 
               
            	/*Para recuperar string de entrada del proceso = resultados*/
            	
               BufferedReader in = new BufferedReader(new InputStreamReader(child.getInputStream()));
               
               /*Inicialisa el archivo de salida donde vamos a escribir los resultados*/ 
            	
               PrintWriter out = new PrintWriter (new BufferedWriter(new FileWriter ("readme.txt")));
            
               while (true){
               					  	  
                  String linea=in.readLine(); 
                  
                  /*Si linea esta null : proceso terminado*/
                  if (linea==null) 
                     break;
                     
                  /*Proxima linea para sacar todas 
               	las lineas con el purcentaje*/
               	
                  if ((linea.contains("compress")&&linea.contains("average"))||(linea.contains("Compress")&&linea.contains("average"))||(linea.contains("decompress")&&linea.contains("%")))
                     continue;
                     
                  else	out.println(linea);
                  
                  if ((linea.contains("ciso")&&linea.contains("compress"))||(linea.contains("ciso")&&linea.contains("decompress"))||(linea.contains("Ciso")&&linea.contains("Decompress"))||(linea.contains("Ciso")&&linea.contains("compress"))||(linea.contains("Ciso")&&linea.contains("estimation")))
                  /*Operacion es un success*/
                     success=1;
               }
            
               out.close();
            } 
            	 /*Si hay excepciones que ocurren en la instruccion try,
            	 el programa va directamente a este linea*/
            	 
                catch (IOException f) {
                  System.out.println("No se pudo ejecutar CisoPlus");
                  System.exit(-1);
               }
         	 
            try {
               /*Esperamos el fin del proceso*/
               child.waitFor();
            }
            
                catch(InterruptedException f ) {
                  System.out.println("No pudimos esperar por termino");
                  System.exit(-1);
               }
         
            if (success==1){  //operacion es un success
               JOptionPane.showMessageDialog(null,"Operacion efectuada.Ver archivo readme.txt para los resultados");
               success=0;
            }
            else 	JOptionPane.showMessageDialog(null,"Operacion no efectuada, verificar los parametros");
         	
         	/*Reinicialisacion de todos los parametros 
         	para efectuar otros operaciones*/
         	
            cmd=accion=opcion=filentrada=filesalida=null;
            entradalabel.setText("Fichero de entrada");
            salidalabel.setText ("Achivo de salida,presione enter para validar");
            salida.setText("");
            ocultarboxopcion();
            opciones.setText("");
            comprimirButton.setEnabled(false);
         	    			    
         }
      }
   
   	 /*Segun la opcion eligida, podemos eligir 
   	 parametros de opciones
   	 Entonces, segun la opcion elegida, boxopcion aparece o no*/
   	 	 
       public void mostrarboxopcion (){
         otropcion.setVisible(true);
         opciones.setVisible(true);	 
      	
      }		
       public void ocultarboxopcion (){
         otropcion.setVisible(false);
         opciones.setVisible(false);	 
      }		
   
   	/*Metodo que crea la ventana : JFrame*/
    
       public static void createAndShowGUI() {
        
         JFrame frame = new JFrame();
         frame.setTitle("Compression/Decompression");
         frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
         frame.add(new CondorISO());
         frame.setSize(1000,250);
         frame.setVisible(true);
      }
   
    /*Funcion princiale main()*/
       public static void main(String[] args) {
      
         SwingUtilities.invokeLater(
                new Runnable() {
               
                   public void run() {
                  //Turn off metal's use of bold fonts
                     UIManager.put("swing.boldMetal", Boolean.FALSE); 
                     createAndShowGUI();
                  }
               });
      }
   
    
    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event dispatch thread.
     */	
   }
		
